;
;
;

OBJ.ADRS     EQU $C000
LABEL.TABLE  EQU $D000
WORK    EQU $DFFF
@      EQU -1


; ROM CALL

GET4HEX  EQU $0410 ;GET HL=HEX4
INPUT    EQU $0003 ;GET 1 LINE
PRINT    EQU $0015 ;MESSAGE PRINT
KEYBF    EQU $11A3
NEWLINE  EQU $0006
PRINTA   EQU $0012
?HEX4    EQU $03BA

 ORG $9000
;
;
; PICTURE-DRIVER-COMPILER
;
;

 JP MAIN
 JP ?LABEL
MAIN
 LD A,$C9
 LD ($1038),A
 LD A,$C3
 LD HL,MAIN
 OUT ($E0),A
 LD (0),A
 LD (1),HL
 OUT ($E4),A

 LD DE,TITLE
 CALL PRINT
 CALL NEWLINE
 LD DE,INPUT'MSG
 CALL PRINT
 CALL NEWLINE
 LD DE,KEYBF     ;$11A3
 CALL INPUT
 CALL GET4HEX
 JP C,$00AD
 LD (TEXT.ADRS),HL

 DI
 OUT ($E1),A
 LD HL,LABEL.TABLE
 LD (LABEL.ADRS),HL
 LD DE,LABEL.TABLE+1
 LD BC,1024*12-1
 LD (HL),-1
 LDIR
 LD HL,OBJ.ADRS
 LD (OBJ.START),HL
;
 CALL COMPILE
 OUT ($E4),A

 LD DE,END'MSG
 CALL PRINT
 LD HL,(OBJ.START)
 CALL $3BA
 LD A,"-"
 CALL $12
 PUSH IY
 POP HL
 DEC HL
 CALL $3BA
;
 JP $00AD

TITLE
 DM "/// PICTURE COMPILER V1.0 ///"
 DB 13
INPUT'MSG
 DM "INPUT TEXT ADDRESS"
 DB 13
END'MSG
 DM "OBJECT CODE END:"
 DB 13
PARAMETER DS 1
ASTOR      DS 2
TSTOR      DS 2
PASS       DS 1
SIGN       DS 1
MKAZU      DS 2
TEXT.ADRS  DS 2
LABEL.ADRS DS 2
OLD.ADRS   DS 2
OBJ.START  DS 2
LNP        DS 2
XP         DS 1
PARA.TBL   DS 32
;
;
;
COMPILE
 XOR A
 LD (PASS),A

COMP
 LD IX,(TEXT.ADRS)
 LD IY,OBJ.ADRS
 LD HL,1
 LD (LNP),HL

CMPLP
 CALL SKIP
 CP ";"
 JP Z,COMMENT
 CP ":"
 JP Z,LABEL.SET
 CP "."
 JP Z,GIJI.SET
 CP "@"
 JR Z,CMPEND
 CP "!"
 JP Z,END.MARK
 CALL COMPARE
 JP C,ERROR2
 CALL OBJECT


 JR CMPLP
CMPEND
 LD HL,LABEL.TABLE
 LD (LABEL.ADRS),HL
 LD A,(PASS)
 OR A
 RET NZ
 INC A
 LD (PASS),A
 JR COMP
;
;
;
SKIP
 LD A,(IX) CALL LNPLUS
 OR A
 JR Z,SK2
 CP "!"
 JR C,SK1
 CP "Z"+1
 RET C
SK1
 INC IX
 JR SKIP
SK2
 POP AF
 JR CMPEND
;
OBJECT
 LD (ASTOR),HL
 CALL GET.PR
 LD HL,PARA.TBL
 LD DE,(ASTOR)
 DEC DE
OBJLP
 INC DE
 EXX
 LD HL,OBJLP
 PUSH HL
 EXX
 LD A,(DE)
 CP ":"
 JR Z,RETURN
 CP "B"
 JR Z,WRT.BYTE
 CP "Z"
 JR Z,WRT.Z
 CP "W"
 JR Z,WRT.WORD
 CP "R"
 JR Z,WRT.REVERSE
 CP -1
 JP Z,WRT.VALUE
;
WRT.NOTHING
 LD (IY),0
 INC IY
 RET
RETURN
 POP AF
 RET
WRT.BYTE
 LD A,(HL)
 LD (IY),A
 INC IY
 INC HL
 INC HL
 RET
WRT.WORD
 LD A,(HL)
 LD (IY),A
 INC HL
 INC IY
 LD A,(HL)
 LD (IY),A
 INC HL
 INC IY
 INC DE
 RET
WRT.Z
 LD A,(HL)
 CP 32
 JP NC,ERROR4
 LD (IY),A
 INC HL
 INC HL
 INC IY
 RET
WRT.REVERSE
 LD A,(IY-1)
 LD (IY),A
 LD A,(HL)
 LD (IY-1),A
 INC HL
 INC HL
 INC IY
 RET
WRT.VALUE
 INC DE
 LD A,(DE)
 LD (IY),A
 INC IY
 RET
;
; GIJIMEIREI
;
GIJI.SET
 LD HL,CMPLP
 PUSH HL
 INC IX
 LD A,(IX) CALL LNPLUS
 INC IX
 CP "!"+1
 JR Z,MSG.OBJ
 CP "'"
 JR Z,MSG.OBJ2
 CP "%"
 JR Z,ORIGIN


 CP "."
 JR Z,WORD.SET
 DEC IX
 CALL KAZU
 LD (IY),L
 INC IY
 RET
WORD.SET
 CALL KAZU
 LD (IY),L
 LD (IY+1),H
 INC IY
 INC IY
 RET
ORIGIN
 CALL KAZU
 PUSH HL
 POP IY
 LD (OBJ.START),HL
 RET
MSG.OBJ2
 LD C,"'"
 JR MSG.O
MSG.OBJ
 LD C,"!"+1
MSG.O
 LD A,(IX) CALL LNPLUS
 INC IX
 CP C
 RET Z
 LD (IY),A
 INC IY
 JR MSG.O
COMMENT
 LD C,";"
 INC IX
CML
 LD A,(IX) CALL LNPLUS
 INC IX
 CP C
 JR NZ,CML
 JP CMPLP
END.MARK
 INC IX
 LD (IY),-1
 INC IY
 JP CMPLP

;
; LABEL SET
;

LABEL.SET
 LD HL,(LABEL.ADRS)
 LD (OLD.ADRS),HL
 LD (HL),1 ;LABEL ON
 INC HL
 INC IX
LS1
 LD A,(IX) CALL LNPLUS
 LD (HL),A
 INC HL
 INC IX
 CP ":"
 JR NZ,LS1
 CALL SKIP
 INC HL
 INC HL
 LD (LABEL.ADRS),HL
 PUSH IY
 POP DE
 LD A,(IX)
 CP "="
 JR NZ,LS2
 INC IX
 CALL SKIP    ;??
 CALL KAZU
 EX DE,HL
 LD HL,(LABEL.ADRS)
LS2
 DEC HL
 LD (HL),D
 DEC HL
 LD (HL),E
 JP CMPLP

;
; GET PARAMETER
;
GET.PR
 LD HL,PARA.TBL
 LD DE,PARA.TBL+1
 LD BC,20
 LD (HL),-1
 LDIR
 XOR A
 LD (PARAMETER),A
 LD HL,PARA.TBL
GPA
 LD (TSTOR),HL
 CALL SKIP.C
 JR C,GPX
 CALL KAZU
 LD DE,HL
 LD HL,(TSTOR)
 LD (HL),E
 INC HL
 LD (HL),D
 INC HL
 LD A,(PARAMETER)
 INC A
 LD (PARAMETER),A
 CP 8
 JP NC,ERROR5
 JR GPA
GPX
 INC IX
 RET
SKIP.L
 INC IX
SKIP.C
 LD A,(IX) CALL LNPLUS
 CP ")"
 SCF
 RET Z
 CP ":"
 RET Z
 CP "$"
 RET Z
 CP "+"
 RET Z
 CP "-"
 RET Z
 CP ","
 JR Z,SKIP.L
 CP " "+1
 JR C,SKIP.L
 CP "Z"+1
 JR NC,SKIP.L
 OR A
 RET
;
;
; MOJI COMPARE!
;
;

COMPARE
 LD (CPRWRT+2),IX
 LD HL,TABLE
 LD B,-1
 LD C,"("
CPR1
 LD A,(HL)
 CP B
 SCF
 RET Z
CPR2
 CP (IX)
 JR NZ,CPR3
 CP C
 JR Z,STR.SET
 INC HL
 INC IX
 LD A,(HL)
 JR CPR2
CPR3
 LD A,(HL)
 INC HL
 CP C
 JR NZ,CPR3
 INC HL
 INC HL
CPRWRT
 LD IX,0
 JR CPR1
STR.SET
 INC HL
 LD E,(HL)
 INC HL
 LD D,(HL)
 EX DE,HL
 INC IX
 RET
;
;
; KAZU WO KEISAN
;
;

KAZU
 LD HL,0
KZLP
 LD (MKAZU),HL
 CALL VALUE
 LD DE,(MKAZU)
 ADD HL,DE
 LD A,(IX)
 CP "+"
 JR Z,KZLP
 CP "-"
 JR Z,KZLP
 RET
;
VALUE
 XOR A
 LD (SIGN),A
 LD A,(IX)
 CP "+"
 JR Z,VL1
 CP "-"
 JR NZ,VL2
VL1
 INC IX
 LD (SIGN),A
VL2
 CALL GET10&16
 LD A,(SIGN)
 CP "-"
 RET NZ
 EX DE,HL
 LD HL,0
 SBC HL,DE
 RET

;
; 10 SINN
; 16 SINN
; LABEL
;        GET SUB
;
GET10&16
 LD A,(IX)
 CP ":"
 JP Z,READ.LABEL
 CP "$"
 JP Z,READ16
 LD HL,0
 LD D,L
 CP "9"+1
 JP NC,ERROR1
 SUB "0"
 JP C,ERROR1
G10
 ADD HL,HL
 LD BC,HL
 ADD HL,HL
 ADD HL,HL
 ADD HL,BC
 LD E,A
 ADD HL,DE  ;HL=HL*10+DE
 INC IX
 LD A,(IX)
 CP "9"+1
 RET NC
 SUB "0"

 RET C
 JR G10
READ16
 INC IX
 LD HL,0
 LD D,L
 CALL GET.HEX
 JP C,ERROR1
 LD L,A
RD16
 INC IX
 CALL GET.HEX
 CCF
 RET NC
 ADD HL,HL
 ADD HL,HL
 ADD HL,HL
 ADD HL,HL
 LD E,A
 ADD HL,DE
 JR RD16
GET.HEX
 LD A,(IX)
 CP "F"+1
 CCF
 RET C
 CP "0"
 RET C
 CP "9"+1
 JR NC,GETH
 SUB "0"
 RET
GETH
 SUB "A"
 RET C
 ADD A,10
 RET
READ.LABEL
 LD A,(PASS)
 OR A
 JR Z,READ.PASS
 INC IX
;
; GET.LABEL.VALUE
;
GET.LABEL.VAL
 LD (GL2+2),IX
 LD HL,LABEL.TABLE
GL0
 LD A,(HL)
 OR A
 JP M,ERROR3
 INC HL
GL1
 LD A,(HL)
 CP ":"
 JR Z,SET.LV
 CP (IX)
 JR NZ,GL2
 INC IX
 INC HL
 JR GL1
GL2
 LD IX,0
GL3
 LD A,(HL)
 INC HL
 CP ":"
 JR NZ,GL3
 INC HL
 INC HL
 JR GL0
SET.LV
 LD A,(IX)
 CP ":"
 JR NZ,GL2
 INC HL
 LD E,(HL)
 INC HL
 LD D,(HL)
 EX DE,HL
 INC IX
 RET
READ.PASS
 INC IX
RP1
 LD A,(IX) CALL LNPLUS
 CP ":"
 INC IX
 JR NZ,RP1
 RET
 ;
;
; LINE PONITER +
;
LNPLUS
 CP 13
 RET NZ
 PUSH AF
 PUSH HL
 ;
 LD HL,LNP
 LD A,(HL)
 ADD A,1
 DAA
 LD (HL),A
 INC HL
 LD A,(HL)
 ADC A,0
 DAA
 LD (HL),A
 ;
 POP HL
 POP AF
 RET
ERROR1
;
; SUUJI NO ERROR
;
 LD DE,MSG1
 JR ERROR
ERROR2
;
; STATEMENT ERRO
;
 LD DE,MSG2
 JR ERROR
ERROR3
;
; NO LABEL ERROR
;
 LD DE,MSG3
 JR ERROR
ERROR4
;
; Z OVER
;
 LD DE,MSG4
 JR ERROR
ERROR5
;
; PARAMETER OVER
;
 LD DE,MSG5
ERROR
 OUT ($E4),A
 CALL $15

 LD HL,(LNP)
 CALL $3BA
 LD A,"("
 CALL $12
 PUSH IX
 POP HL
 CALL $3BA
 LD A,"H"
 CALL $12
 LD A,")"
 CALL $12
 CALL 6
 LD SP,$10F0
 JP $00AD

MSG1
 DM "PARAMETER ERROR IN "
 DB 13
MSG2
 DM "UNDEFINED STATEMENT IN "
 DB 13
MSG3
 DM "UNDEFINED LABEL IN "
 DB 13
MSG4
 DM "Z OVER IN "
 DB 13
MSG5
 DM "PARAMETER OVER IN "
 DB 13

;
; PRINT LABEL
;
?LABEL
 CALL NEWLINE
 LD IX,LABEL.TABLE
?LA0
 CALL $1E
 JP Z,$00AD
 OUT ($E1),A
 LD A,(IX)
 OUT ($E4),A
 OR A
 JP M,$00AD
 INC IX
?LA1
 OUT ($E1),A
 LD A,(IX)
 OUT ($E4),A
 CP ":"
 JR Z,?LA2
 CALL PRINTA
 INC IX
 JR ?LA1
?LA2
 LD A,22
 LD ($1171),A ;X
 INC IX
 OUT ($E1),A
 LD L,(IX)
 LD H,(IX+1)
 OUT ($E4),A
 INC IX
 INC IX
 CALL ?HEX4
 CALL NEWLINE
 CALL PAUSE
 JR ?LA0
PAUSE
 CALL $001B
 CP " "
 RET NZ
P1
 CALL $1B
 CP " "
 JR Z,P1
P2
 CALL $1B
 OR A
 JR Z,P2
 RET

;
; COMPARE TABLE
;

TABLE
;
; MASINGO MEIREI
;
 DM "#SCENE("          DW GIJI1
 DM "#MSG("            DW GIJI2
 DM "#GOTO("           DW GIJI3
 DM "#RET("            DW GIJI4
 DM "#HOT("            DW GIJI5
 DM "#COLD("           DW GIJI6
 DM "#CALL("          DW GIJI7
 DM "#CLR("           DW GIJI8
 DM "#INIT("          DW GIJI9
 DM "#MSG.TBL("       DW GIJI10
 DM "#NAME.TBL("      DW GIJI11
 DM "#AUTO("      DW GIJI12
 DM "#MANUAL("    DW GIJI13


 DM "END("             DW TYP0
 DM "PUT("             DW TYP1
;DM "PUT.CHR("         DW TYP2
;DM "PUT.ATB("         DW TYP3
 DM "PUT.HYP("         DW TYP4
;DM "PUT.HYP.CHR("     DW TYP5
;DM "PUT.HYP.ATB("     DW TYP6
 DM "BOX("             DW TYP7
 DM "BOX.CHR("         DW TYP8
 DM "BOX.ATB("         DW TYP9
 DM "LINE("            DW TYP10
 DM "LINE.CHR("        DW TYP11
 DM "LINE.ATB("        DW TYP12
 DM "CLS("             DW TYP13
 DM "CLS.CHR("         DW TYP14
 DM "CLS.ATB("         DW TYP15
 DM "BOX.FILL("        DW TYP16
 DM "BOX.FILL.CHR("    DW TYP17
 DM "BOX.FILL.ATB("    DW TYP18
;DM "TRANS30("         DW TYP19
 DM "TRANS40("         DW TYP20
 DM "TRANS("           DW TYP21
 DM "GRAD("            DW TYP22
;DM "GRAD.CHR("        DW TYP23
;DM "GRAD.ATB("        DW TYP24
 DM "STAR("            DW TYP25
 DM "PRINT("           DW TYP26
 DM "WAIT("            DW TYP27
 DM "DO("              DW TYP28
 DM "LOOP("            DW TYP29
 DM "SET.CXY("         DW TYP30
;DM "TRANS30.CXY("     DW TYP31
 DM "TRANS40.CXY("     DW TYP32
 DM "TRANS.CXY("       DW TYP33
 DM "MOVE.CXY("        DW TYP34
 DM "CIRCLE("          DW TYP35
;DM "CIRCLE.CHR("      DW TYP36
;DM "CIRCLE.ATB("      DW TYP37
 DM "CHANGE("          DW TYP38
 DM "SCRL.U("          DW TYP39
 DM "SCRL.D("          DW TYP40
 DM "SCRL.L("          DW TYP41
 DM "SCRL.R("          DW TYP42
;DM "SCRL.U.CHR("      DW TYP43
;DM "SCRL.D.CHR("      DW TYP44
;DM "SCRL.L.CHR("      DW TYP45
;DM "SCRL.R.CHR("      DW TYP46
;DM "SCRL.U.ATB("      DW TYP47
;DM "SCRL.D.ATB("      DW TYP48
;DM "SCRL.L.ATB("      DW TYP49
;DM "SCRL.R.ATB("      DW TYP50
 DM "COPY("            DW TYP51
;DM "COPY.CHR("        DW TYP52
;DM "COPY.ATB("        DW TYP53
 DM "SET.GXY("         DW TYP54
 DM "MOVE.GXY("        DW TYP55
 DM "PUT.SMALL("       DW TYP56
 DM "PUT.LARGE("       DW TYP57
 DM "PUT.OVER("        DW TYP58
 DM "CALL("            DW TYP59
 DM "GOSUB("           DW TYP60
 DM "RET("             DW TYP61
 DM "PUT.GXY("         DW TYP62
 DM "PUT.HYP.GXY("     DW TYP63
 DM "PUT.OVER.GXY("    DW TYP64
 DM "LINE.GXY("        DW TYP65
 DM "CIRCLE.GXY("      DW TYP66
 DM "BOX.GXY("         DW TYP67
 DM "BOX.FILL.GXY("    DW TYP68
 DM "COPYM("           DW TYP69
 DM "LOAD.MXY("        DW TYP70
 DM "SAVE.MXY("        DW TYP71
 DM "PLUS.MXY("        DW TYP72
 DM "MXY.TO.GXY("      DW TYP73
 DM "GXY.TO.MXY("      DW TYP74
 DM "EFFECT("          DW TYP75
 DM "SET.MXY("         DW TYP76
 DM "SET.PXY("         DW TYP77
 DM "MOVE.MXY("        DW TYP78
 DM "MOVE.PXY("        DW TYP79
 DM "PXY.TO.CXY("      DW TYP80
 DM "PXY.TO.GXY("      DW TYP81
 DM "PXY.TO.MXY("      DW TYP82
;DM "LINE.GXY+("       DW TYP83
;DM "BOX.GXY+("        DW TYP84
 DM "MUSIC("           DW TYP85
 DM "TEMPO("        DW TYP86
 DB -1
;
;
; FUNCTION COMPILE TABLE
;
;

GIJI1
 DB @:$DD:@:$21 DM "WN"
 DB @:$CD:@:$00:@:$A6 ;PICT ADRS
 DM ":"
GIJI2
 DB @:$06 DM "B"
 DB @:$CD:@:$18:@:$A6 ;KAIWA
 DM ":"
GIJI3
 DB @:$C3 DM "WN:" ;JP X
GIJI4
 DB @:$C9 DM ":"
GIJI5
 DB @:$C3:@:$AD:@:0 DM ":"
GIJI6
 DB @:$C3:@:0:@:0 DM ":"
GIJI7
 DB @:$CD DM "WN:"
GIJI8
 DB @:$AF:@:$32:@:$FF:@:$DF
 DM ":"
GIJI9
 DB @:$AF:@:$CD:@:0:@:$B0
 DB @:$3E:@:$C9:@:$32:@:$38
 DB @:$10
 DM ":"
GIJI10
 DB @:$21 DM "WN"
 DB @:$CD:@:$15:@:$A6
 DM ":"
GIJI11
 DB @:$21 DM "WN"
 DB @:$CD:@:$12:@:$A6
 DM ":"
GIJI12
 DB @:$AF:@:$CD:@:$1B:@:$A6
 DM ":"
GIJI13
 DB @:$3E:@:$01:@:$CD:@:$1B
 DB @:$A6 DM ":"

TYP0 DB @:-1 DM ":" ;ENDCODE
TYP1  DB @:1  DM "BRBRWNZ:"
;TYP2  DB @:2  DM "BRBRWNZ:"
;TYP3  DB @:3  DM "BRBRWNZ:"
TYP4  DB @:4  DM "BRBRWNZ:"
;TYP5  DB @:5  DM "BRBRWNZ:"
;TYP6  DB @:6  DM "BRBRWNZ:"
TYP7  DB @:7  DM "BRBRBBZ:"
TYP8  DB @:8  DM "BRBRBNZ:"
TYP9  DB @:9  DM "BRBRNBZ:"
TYP10 DB @:10 DM "BRBRBBZ:"
TYP11 DB @:11 DM "BRBRBNZ:"
TYP12 DB @:12 DM "BRBRNBZ:"
TYP13 DB @:13 DM "NNNNBBZ:"
TYP14 DB @:14 DM "NNNNBNZ:"
TYP15 DB @:15 DM "NNNNNBZ:"
TYP16 DB @:16 DM "BRBRBBZ:"
TYP17 DB @:17 DM "BRBRBNZ:"
TYP18 DB @:18 DM "BRBRNBZ:"
;TYP19 DB @:19 DM "BRBNWNZ:"
TYP20 DB @:20 DM "BRBNWNZ:"
TYP21 DB @:19
 DM "BR" DB @:18 DM "N"
 DB @:$2D:@:$D0 DM "Z:"
TYP22 DB @:22 DM "NBNNWNZ:"
;TYP23 DB @:23 DM "NBNNWNZ:"
;TYP24 DB @:24 DM "NBNNWNZ:"
TYP25 DB @:25 DM "NNNNWNZ:"
TYP26 DB @:26 DM "NNBBWNZ:"
TYP27 DB @:27 DM "BWNNNNZ:"
TYP28 DB @:28 DM "BNNNNNZ:"
TYP29 DB @:29 DM "NNNNNNZ:"
TYP30 DB @:30 DM "BRNNNNZ:"
;TYP31 DB @:31 DM "NNBNWNZ:"
TYP32 DB @:32 DM "NNBNWNZ:"
TYP33 DB @:31
 DM "NN" DB @:18 DM "N"
 DB @:$2D:@:$D0 DM "Z:"
TYP34 DB @:34 DM "BRNNNNZ:"
TYP35 DB @:35 DM "BRBNBBZ:"
;TYP36 DB @:36 DM "BRBNBNZ:"
;TYP37 DB @:37 DM "BRBNNBZ:"
TYP38 DB @:38 DM "BNWNWNZ:"
TYP39 DB @:39 DM "BRBRNNZ:"
TYP40 DB @:40 DM "BRBRNNZ:"
TYP41 DB @:41 DM "BRBRNNZ:"
TYP42 DB @:42 DM "BRBRNNZ:"
;TYP43 DB @:43 DM "BRBRNNZ:"
;TYP44 DB @:44 DM "BRBRNNZ:"
;TYP45 DB @:45 DM "BRBRNNZ:"
;TYP46 DB @:46 DM "BRBRNNZ:"
;TYP47 DB @:47 DM "BRBRNNZ:"
;TYP48 DB @:48 DM "BRBRNNZ:"
;TYP49 DB @:49 DM "BRBRNNZ:"
;TYP50 DB @:50 DM "BRBRNNZ:"
TYP51 DB @:51 DM "BRBRBNZ:"
;TYP52 DB @:52 DM "BRBRBNZ:"
;TYP53 DB @:53 DM "BRBRBNZ:"
TYP54 DB @:54 DM "BRNNNNZ:"
TYP55 DB @:55 DM "BRNNNNZ:"
TYP56 DB @:56 DM "BRBRWNZ:"
TYP57 DB @:57 DM "BRBRWNZ:"
TYP58 DB @:58 DM "BRBRWNZ:"
TYP59 DB @:59 DM "WNNNNNZ:"
TYP60 DB @:60 DM "WNNNNNZ:"
TYP61 DB @:61 DM "NNNNNNZ:"
TYP62 DB @:62 DM "BRBRWNZ:"
TYP63 DB @:63 DM "BRBRWNZ:"
TYP64 DB @:64 DM "BRBRWNZ:"
TYP65 DB @:65 DM "BRBRBBZ:"
TYP66 DB @:66 DM "BRBNBBZ:"
TYP67 DB @:67 DM "BRBRBBZ:"
TYP68 DB @:68 DM "BRBRBBZ:"
TYP69 DB @:69 DM "WNWNWNZ:"
TYP70 DB @:70 DM "WNNNNNZ:"
TYP71 DB @:71 DM "WNNNNNZ:"
TYP72 DB @:72 DM "BRNNNNZ:"
TYP73 DB @:73 DM "WNNNNNZ:"
TYP74 DB @:74 DM "WNNNNNZ:"
TYP75 DB @:75 DM "BRBRBBZ:"
TYP76 DB @:76 DM "BRWNNNZ:"
TYP77 DB @:77 DM "BRBRNNZ:"
TYP78 DB @:78 DM "BRWNNNZ:"
TYP79 DB @:79 DM "NNNNNNZ:"
TYP80 DB @:80 DM "NNNNNNZ:"
TYP81 DB @:81 DM "NNNNNNZ:"
TYP82 DB @:82 DM "WNNNNNZ:"
;TYP83 DB @:83 DM "BRBRBBZ:"
;TYP84 DB @:84 DM "BRBRBBZ:"
TYP85 DB @:85 DM "WNNNNNZ:"
TYP86 DB @:85 DM "BNNNNNZ:"
